%setup global f and H matrices
function [H,f] = getHfRev3(H,f,felem,Helem,nele,L)
for i=1:7
    for j=1:7
        H(i,j)=H(i,j)+Helem(1,i,j);
    end
    f(i)=f(i)+felem(1,i);
end
for i=2:nele
    for j=1:3
        for k=1:3
            H(3+k+(i-2)*4,3+j+(i-2)*4)=H(3+k+(i-2)*4,3+j+(i-2)*4)+Helem(i,k,j);
        end
        for k=4:7
            H(4+k+(i-2)*4,3+j+(i-2)*4)=H(4+k+(i-2)*4,3+j+(i-2)*4)+Helem(i,k,j);
        end
        f(3+j+(i-2)*4)=f(3+j+(i-2)*4)+felem(i,j);
    end
    for j=4:7
        for k=1:3
            H(3+k+(i-2)*4,4+j+(i-2)*4)=H(3+k+(i-2)*4,4+j+(i-2)*4)+Helem(i,k,j);
        end
        for k=4:7
            H(4+k+(i-2)*4,4+j+(i-2)*4)=H(4+k+(i-2)*4,4+j+(i-2)*4)+Helem(i,k,j);
        end
        f(4+j+(i-2)*4)=f(4+j+(i-2)*4)+felem(i,j);
    end
end
%H(abs(H)<1e-14)=0;
Hmin=H;
Hmin(Hmin==0)=inf;
minH=1e-4/L;%1/m=1e-3 to 1e-6 * lengthscale/L 
H(1,1)=H(1,1)+minH; %Avoid of singular
H(2,2)=H(2,2)+minH;
for i=1:nele
   H(i*4,i*4)=H(i*4,i*4)+minH;
   H(i*4+1,i*4+1)=H(i*4+1,i*4+1)+minH;
end